#import "SignXml3Plugin.h"
#import "SignNUC.h"
#include "XMLSigner.h"
@implementation SignXml3Plugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"signXml3"
            binaryMessenger:[registrar messenger]];
  SignXml3Plugin* instance = [[SignXml3Plugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
//xmlsignersign();
    NSString * pinCode = call.arguments[@"pinCode"];// @"Zz123456";
    NSString * fileName =call.arguments[@"fileName"];// @"RSA256_129ae9c3400aef7471cb4ff729691af7e23f7253";
    NSString * xmlForSign =call.arguments[@"xmlForSign"];// @"<root>test</root>";
    NSString * dataSign = [NSString alloc];
    if ([@"signXml" isEqualToString:call.method]) {
        int resultSign = [SignNUC xmlSigner:&dataSign withDATA:xmlForSign CertName:[[fileName lastPathComponent] stringByDeletingPathExtension] andPassword:pinCode];
        if(resultSign == 0)
        {
            result(dataSign);
        }
        else
        {
            result( [NSString stringWithFormat: @"%d", resultSign]);
        }
    }

//  if ([@"getPlatformVersion" isEqualToString:call.method]) {
//    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
//  } else {
//    result(FlutterMethodNotImplemented);
//  }
}

@end
